'----------------------------------------------------------------------
'
' Copyright 2015 Elba Corp.
' All rights reserved.
'
' Non-exclusive permission to use, copy, modify, and distribute this
' software for any purpose and without fee is hereby granted, provided:
'   1) that the above copyright notice is retained in the source code and,
'   2) that it is understood and agreed that no warranty of any kind,
'      express or implied is provided.
' Use of this code in any manner shall be prima facie evidence of
' acceptance of these terms.
'
' You may contact the author by email at dkinzer@zbasic.net.
'
'----------------------------------------------------------------------

' This example application demonstrates how to use the Wifi.Scan() System
' Library routine.

Option ConsoleSpeed 230400
Option UserPostInit myPostInit
Option Include WifiScan_t

Dim state as Integer

' this table gives the descriptions of the authorization mode values
Private authMode as StringVectorData ({
	"Open    "
	"WEP     "
	"WPA     "
	"WPA2    "
	"WPA/WPA2"
	"Unknown "
})

Sub Main()
	If (state = 0) Then
		Call dspAccessPoints()
	End If

	' sdvance the state counter and then sleep for 1mS
	state = state + 1
	If (state >= 1000) Then
		state = 1
	End If
	Call Sleep(1)
End Sub

Sub myPostInit()
	Wifi.SetMode(1)
	Wifi.SetHostName("ESP8266")
End Sub

'
'' dspAccessPoints
'
' Output information about available access points.
'
Sub dspAccessPoints()
	Dim apCount as UnsignedInteger
	Dim apList(1 to 30) as WifiScan_t

	' populate the AP list
	Debug.Print "scanning ...";
	apCount = Wifi.Scan(apList, UBound(apList))
	Debug.Print " completed, "; apCount; " access points found"

	If (apCount = 0) Then
		Debug.Print "No access points found."
	Else
		Debug.Print "Ch.  RSSI  Auth     SSID"

		' output the information
		Dim i as UnsignedInteger
		Dim auth as Byte
		For i = 1 to apCount
			Debug.Print Left(CStr(apList(i).chan) & "     ", 5);
			Debug.Print Left(CStr(apList(i).rssi) & "     ", 6);
			auth = apList(i).auth
			If (auth > 5) Then 	auth = 5
			Debug.Print authMode(auth + 1); " "; apList(i).ssid
		Next i
	End If
End Sub

